import es, dnd, popuplib, spe, cmdlib, random, gamethread, math, weaponlib
from dnd import dnd
from spe import HookAction
from spe import HookType

def load():
    spe.parseINI('dnd/subscripts/signatures/mysigs.ini')
    spe.parseTypesINI('dnd/subscripts/signatures/mytypes.ini')
    spe.detourFunction('Respawn', HookType.Pre, pre_spawn)
    cmdlib.registerClientCommand('!hide', hide, 'Rogue Ability - Instantly goes into stealth')
    Rogue_Info = popuplib.create('Rogue Info')
    Rogue_Info.addline('Rogue Class Information:')
    Rogue_Info.addline('  Stealthed - Harder to see when not in combat')
    Rogue_Info.addline('  Level 2: Sneak Attack - deals extra damage when stealthed')
    Rogue_Info.addline('  Level 3: Dodge')
    Rogue_Info.addline('  Level 7: Opportunist - Extra damage to enemies')
    Rogue_Info.addline('    not attacking you')
    Rogue_Info.addline('  Level 9: !hide - Instantly go back into stealth 1/round')
    Rogue_Info.addline('    Fails against wise opponents')
    Rogue_Info.addline('-> 9. Main Menu')
    Rogue_Info.submenu(9, 'main_menu')
    
def unload():
    popuplib.delete('Rogue Info')
    cmdlib.unregisterClientCommand('!hide')
    spe.undetourFunction('Respawn', HookType.Pre, pre_spawn)
    
    
def pre_spawn(args):
    userid = es.getuserid(es.gethandlefromindex(spe.getEntityIndex(args[0])))
    if dnd.Player(userid).getClass() == 'Rogue':
        dnd.Temp(userid).add('Fortitude', dnd.Player(userid).getLevel()/3)
        dnd.Temp(userid).add('Reflex', dnd.Player(userid).getLevel()/2+2)
        dnd.Temp(userid).add('Will', dnd.Player(userid).getLevel()/3)
        newStealth = -145-(dnd.Player(userid).getLevel()/2*7)
        dnd.Temp(userid).add('stealth', newStealth)
        if dnd.Player(userid).getLevel() >= 3:
            dnd.Temp(userid).add('dodge percent', 10)
        if dnd.Player(userid).getLevel() >= 9:
            dnd.Temp(userid).add('hide', 1)    
    return (HookAction.Continue, 0)
            
def hide(userid, args):
    if dnd.Player(userid).alive():
        if dnd.Player(userid).getClass() == 'Rogue' and dnd.Player(userid).getLevel() >= 9:
            if dnd.Temp(userid).get('stealthed'):
                dnd.dndTell(userid, 'You are already stealthed!')
            else:
                if dnd.Temp(userid).get('hide'):
                    dnd.Temp(userid).add('hide', -1)
                    gamethread.cancelDelayed('stealth_%s'%userid)
                    dnd.stealth(userid)
                else:
                    dnd.dndTell(userid, 'You can\'t hide again this round!')
                
def item_pickup(ev):
    if dnd.Player(ev['userid']).getClass() == 'Rogue':
        if dnd.Temp(ev['userid']).get('stealthed'):
            handle = es.getplayerhandle(ev['userid'])
            stealth = dnd.Temp(ev['userid']).get('stealth')
            color  = 255 + (255 << 8) + (255 << 16)
            color += stealth << 24
            if color >= 2**31: color -= 2**32
            for x in weaponlib.getIndexList('#all'):
                if es.getindexprop(x, 'CBaseEntity.m_hOwnerEntity') == handle:
                    es.setindexprop(x, "CBaseEntity.m_nRenderMode", es.getindexprop(x, "CBaseEntity.m_nRenderMode") | 1)
                    es.setindexprop(x, "CBaseEntity.m_nRenderFX", es.getindexprop(x, "CBaseEntity.m_nRenderFX") | 256)
                    es.setindexprop(x, "CBaseEntity.m_clrRender", color)
    